package com.servicemall.loyalty.data;

import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import team.bangbang.common.CommonMPI;

/**
 * 礼遇计划 - POJO
 * 对应数据库表：loyalty_plan_base
 *
 * @author 南瑞信通
 * @version 1.0  2020-12-08
 */
public class Plan {
	/* 编号（关键字） */
	private Long id = null;

	/* 礼遇名称 */
	private String loyaltyName = null;
	
	/* 购买数量限制 */
	private Integer buyAmountLimit = null;
	
	/* 是否显示在精选位置{0:否 1:是} */
	private Integer selectedStatus = null;
	
	/* 核销时是否绑定车辆使用{0:否 1:是} */
	private Integer bindingUseStatus = null;
	
	/* 厂家价格,单位 元 */
	private Double factoryGuidePrice = null;
	
	/* 售价类型{1:统一价格 2:车型动态价格} */
	private Integer priceTypeFlag = null;
	
	/* 统一售价,单位 元 */
	private Double uniformPrice = null;
	
	/* 付款方式{1:定金 2:全款} */
	private Integer payTypeFlag = null;
	
	/* 定金比例 */
	private Double depositRatio = null;
	
	/* 定金金额，单位元 */
	private Double depositPrice = null;
	
	/* 适用车龄 */
	private String applyOld = null;
	
	/* 是否加入购物车{0:否 1:是} */
	private Integer cartEnableStatus = null;
	
	/* 计划描述 */
	private String description = null;
	
	/* 购买限制说明 */
	private String buyLimitDescription = null;
	
	/* 计划图片 */
	private String planImage = null;
	
	/* 活动轮播图 */
	private String activityImage = null;
	
	/* 删除状态{0:否 1:是} */
	private Integer delStatus = null;
	
	/* 生效状态{1:待生效 2:生效中 3:已暂停 4:已结束} */
	private Integer activeStatus = null;
	
	/* 创建人编号 */
	private Long creatorId = null;
	
	/* 修改人编号 */
	private Long updatorId = null;
	
	/* 购买起始时间 */
	@DateTimeFormat(pattern="yyyy-MM-dd")
	private Date buyStartTime = null;
	/* 购买起始时间 （查询上线） */
	private Date buyStartTimeTop = null;
	/* 购买起始时间 （查询下线） */
	private Date buyStartTimeBottom = null;
	
	/* 购买结束时间 */
	@DateTimeFormat(pattern="yyyy-MM-dd")
	@JsonFormat(pattern="yyyy-MM-dd",timezone="GMT+8")
	private Date buyEndTime = null;
	/* 购买结束时间 （查询上线） */
	private Date buyEndTimeTop = null;
	/* 购买结束时间 （查询下线） */
	private Date buyEndTimeBottom = null;
	
	/* 创建时间 */
	private Date createAt = null;
	/* 创建时间 （查询上线） */
	private Date createAtTop = null;
	/* 创建时间 （查询下线） */
	private Date createAtBottom = null;
	
	/* 更新时间 */
	private Date updateAt = null;
	/* 更新时间 （查询上线） */
	private Date updateAtTop = null;
	/* 更新时间 （查询下线） */
	private Date updateAtBottom = null;
	
	/*
	 * 固定数据字典 售价类型{1:统一价格 2:车型动态价格}
	 */
	public static final String[] priceTypeFlags = { "售价类型{1:统一价格 2:车型动态价格}" };

	/*
	 * 固定数据字典 付款方式{1:定金 2:全款}
	 */
	public static final String[] payTypeFlags = { "付款方式{1:定金 2:全款}" };

	/**
	 * @return 编号
	 */
	public Long getId() {
		return id;
	}

	/**
	 * @param id 编号
	 */
	public void setId(Long id) {
		this.id = id;
	}

	/**
	 * @return 礼遇名称
	 */
	public String getLoyaltyName() {
		return loyaltyName;
	}

	/**
	 * @param loyaltyName 礼遇名称
	 */
	public void setLoyaltyName(String loyaltyName) {
		this.loyaltyName = loyaltyName;
	}

	/**
	 * @return 购买数量限制
	 */
	public Integer getBuyAmountLimit() {
		return buyAmountLimit;
	}

	/**
	 * @param buyAmountLimit 购买数量限制
	 */
	public void setBuyAmountLimit(Integer buyAmountLimit) {
		this.buyAmountLimit = buyAmountLimit;
	}

	/**
	 * @return 是否显示在精选位置{0:否 1:是}
	 */
	public Integer getSelectedStatus() {
		return selectedStatus;
	}

	/**
	 * @param selectedStatus 是否显示在精选位置{0:否 1:是}
	 */
	public void setSelectedStatus(Integer selectedStatus) {
		this.selectedStatus = selectedStatus;
	}

	/**
	 * @return 核销时是否绑定车辆使用{0:否 1:是}
	 */
	public Integer getBindingUseStatus() {
		return bindingUseStatus;
	}

	/**
	 * @param bindingUseStatus 核销时是否绑定车辆使用{0:否 1:是}
	 */
	public void setBindingUseStatus(Integer bindingUseStatus) {
		this.bindingUseStatus = bindingUseStatus;
	}

	/**
	 * @return 厂家价格,单位 元
	 */
	public Double getFactoryGuidePrice() {
		return factoryGuidePrice;
	}

	/**
	 * @param factoryGuidePrice 厂家价格,单位 元
	 */
	public void setFactoryGuidePrice(Double factoryGuidePrice) {
		this.factoryGuidePrice = factoryGuidePrice;
	}

	/**
	 * @return 售价类型{1:统一价格 2:车型动态价格}
	 */
	public Integer getPriceTypeFlag() {
		return priceTypeFlag;
	}

	/**
	 * @param priceTypeFlag 售价类型{1:统一价格 2:车型动态价格}
	 */
	public void setPriceTypeFlag(Integer priceTypeFlag) {
		this.priceTypeFlag = priceTypeFlag;
	}

	/**
	 * @return 售价类型{1:统一价格 2:车型动态价格}名称
	 */
	public String getPriceTypeName() {
		Integer nFlag = getPriceTypeFlag();
		return CommonMPI.getDictionaryName(priceTypeFlags, nFlag);
	}
	
	/**
	 * @return 统一售价,单位 元
	 */
	public Double getUniformPrice() {
		return uniformPrice;
	}

	/**
	 * @param uniformPrice 统一售价,单位 元
	 */
	public void setUniformPrice(Double uniformPrice) {
		this.uniformPrice = uniformPrice;
	}

	/**
	 * @return 付款方式{1:定金 2:全款}
	 */
	public Integer getPayTypeFlag() {
		return payTypeFlag;
	}

	/**
	 * @param payTypeFlag 付款方式{1:定金 2:全款}
	 */
	public void setPayTypeFlag(Integer payTypeFlag) {
		this.payTypeFlag = payTypeFlag;
	}

	/**
	 * @return 付款方式{1:定金 2:全款}名称
	 */
	public String getPayTypeName() {
		Integer nFlag = getPayTypeFlag();
		return CommonMPI.getDictionaryName(payTypeFlags, nFlag);
	}
	
	/**
	 * @return 定金比例
	 */
	public Double getDepositRatio() {
		return depositRatio;
	}

	/**
	 * @param depositRatio 定金比例
	 */
	public void setDepositRatio(Double depositRatio) {
		this.depositRatio = depositRatio;
	}

	/**
	 * @return 定金金额，单位元
	 */
	public Double getDepositPrice() {
		return depositPrice;
	}

	/**
	 * @param depositPrice 定金金额，单位元
	 */
	public void setDepositPrice(Double depositPrice) {
		this.depositPrice = depositPrice;
	}

	/**
	 * @return 适用车龄
	 */
	public String getApplyOld() {
		return applyOld;
	}

	/**
	 * @param applyOld 适用车龄
	 */
	public void setApplyOld(String applyOld) {
		this.applyOld = applyOld;
	}

	/**
	 * @return 是否加入购物车{0:否 1:是}
	 */
	public Integer getCartEnableStatus() {
		return cartEnableStatus;
	}

	/**
	 * @param cartEnableStatus 是否加入购物车{0:否 1:是}
	 */
	public void setCartEnableStatus(Integer cartEnableStatus) {
		this.cartEnableStatus = cartEnableStatus;
	}

	/**
	 * @return 计划描述
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * @param description 计划描述
	 */
	public void setDescription(String description) {
		this.description = description;
	}

	/**
	 * @return 购买限制说明
	 */
	public String getBuyLimitDescription() {
		return buyLimitDescription;
	}

	/**
	 * @param buyLimitDescription 购买限制说明
	 */
	public void setBuyLimitDescription(String buyLimitDescription) {
		this.buyLimitDescription = buyLimitDescription;
	}

	/**
	 * @return 计划图片
	 */
	public String getPlanImage() {
		return planImage;
	}

	/**
	 * @param planImage 计划图片
	 */
	public void setPlanImage(String planImage) {
		this.planImage = planImage;
	}

	/**
	 * @return 活动轮播图
	 */
	public String getActivityImage() {
		return activityImage;
	}

	/**
	 * @param activityImage 活动轮播图
	 */
	public void setActivityImage(String activityImage) {
		this.activityImage = activityImage;
	}

	/**
	 * @return 删除状态{0:否 1:是}
	 */
	public Integer getDelStatus() {
		return delStatus;
	}

	/**
	 * @param delStatus 删除状态{0:否 1:是}
	 */
	public void setDelStatus(Integer delStatus) {
		this.delStatus = delStatus;
	}

	/**
	 * @return 生效状态{1:待生效 2:生效中 3:已暂停 4:已结束}
	 */
	public Integer getActiveStatus() {
		return activeStatus;
	}

	/**
	 * @param activeStatus 生效状态{1:待生效 2:生效中 3:已暂停 4:已结束}
	 */
	public void setActiveStatus(Integer activeStatus) {
		this.activeStatus = activeStatus;
	}

	/**
	 * @return 创建人编号
	 */
	public Long getCreatorId() {
		return creatorId;
	}

	/**
	 * @param creatorId 创建人编号
	 */
	public void setCreatorId(Long creatorId) {
		this.creatorId = creatorId;
	}

	/**
	 * @return 修改人编号
	 */
	public Long getUpdatorId() {
		return updatorId;
	}

	/**
	 * @param updatorId 修改人编号
	 */
	public void setUpdatorId(Long updatorId) {
		this.updatorId = updatorId;
	}

	/**
	 * @return 购买起始时间
	 */
	public Date getBuyStartTime() {
		return buyStartTime;
	}

	/**
	 * @param buyStartTime 购买起始时间
	 */
	public void setBuyStartTime(Date buyStartTime) {
		this.buyStartTime = buyStartTime;
	}

	/**
	 * @return 购买起始时间（查询上线）
	 */
	public Date getBuyStartTimeTop() {
		return buyStartTimeTop;
	}

	/**
	 * @param buyStartTimeTop 购买起始时间（查询上线）
	 */
	public void setBuyStartTimeTop(Date buyStartTimeTop) {
		this.buyStartTimeTop = buyStartTimeTop;
	}

	/**
	 * @return 购买起始时间（查询下线）
	 */
	public Date getBuyStartTimeBottom() {
		return buyStartTimeBottom;
	}

	/**
	 * @param buyStartTimeBottom 购买起始时间（查询下线）
	 */
	public void setBuyStartTimeBottom(Date buyStartTimeBottom) {
		this.buyStartTimeBottom = buyStartTimeBottom;
	}
	
	/**
	 * @return 购买结束时间
	 */
	public Date getBuyEndTime() {
		return buyEndTime;
	}

	/**
	 * @param buyEndTime 购买结束时间
	 */
	public void setBuyEndTime(Date buyEndTime) {
		this.buyEndTime = buyEndTime;
	}

	/**
	 * @return 购买结束时间（查询上线）
	 */
	public Date getBuyEndTimeTop() {
		return buyEndTimeTop;
	}

	/**
	 * @param buyEndTimeTop 购买结束时间（查询上线）
	 */
	public void setBuyEndTimeTop(Date buyEndTimeTop) {
		this.buyEndTimeTop = buyEndTimeTop;
	}

	/**
	 * @return 购买结束时间（查询下线）
	 */
	public Date getBuyEndTimeBottom() {
		return buyEndTimeBottom;
	}

	/**
	 * @param buyEndTimeBottom 购买结束时间（查询下线）
	 */
	public void setBuyEndTimeBottom(Date buyEndTimeBottom) {
		this.buyEndTimeBottom = buyEndTimeBottom;
	}
	
	/**
	 * @return 创建时间
	 */
	public Date getCreateAt() {
		return createAt;
	}

	/**
	 * @param createAt 创建时间
	 */
	public void setCreateAt(Date createAt) {
		this.createAt = createAt;
	}

	/**
	 * @return 创建时间（查询上线）
	 */
	public Date getCreateAtTop() {
		return createAtTop;
	}

	/**
	 * @param createAtTop 创建时间（查询上线）
	 */
	public void setCreateAtTop(Date createAtTop) {
		this.createAtTop = createAtTop;
	}

	/**
	 * @return 创建时间（查询下线）
	 */
	public Date getCreateAtBottom() {
		return createAtBottom;
	}

	/**
	 * @param createAtBottom 创建时间（查询下线）
	 */
	public void setCreateAtBottom(Date createAtBottom) {
		this.createAtBottom = createAtBottom;
	}
	
	/**
	 * @return 更新时间
	 */
	public Date getUpdateAt() {
		return updateAt;
	}

	/**
	 * @param updateAt 更新时间
	 */
	public void setUpdateAt(Date updateAt) {
		this.updateAt = updateAt;
	}

	/**
	 * @return 更新时间（查询上线）
	 */
	public Date getUpdateAtTop() {
		return updateAtTop;
	}

	/**
	 * @param updateAtTop 更新时间（查询上线）
	 */
	public void setUpdateAtTop(Date updateAtTop) {
		this.updateAtTop = updateAtTop;
	}

	/**
	 * @return 更新时间（查询下线）
	 */
	public Date getUpdateAtBottom() {
		return updateAtBottom;
	}

	/**
	 * @param updateAtBottom 更新时间（查询下线）
	 */
	public void setUpdateAtBottom(Date updateAtBottom) {
		this.updateAtBottom = updateAtBottom;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	public int hashCode() {
		return (getId() == null)?0:getId().toString().hashCode();
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	public boolean equals(Object obj) {
		if(getId() == null || obj == null || !(obj instanceof Plan)) {
			return false;
		}

		return getId().equals(((Plan)obj).getId());
	}
}
