package com.servicemall.systemcommon.data;

import org.apache.commons.codec.binary.StringUtils;

/**
 * 错误枚举类
 *
 * @author Warren
 */
public enum ErrorEnum {
    /**
     * 公共返回码
     **/
    E_100(200, "成功"),

    E_201(201, "请求次数超限或者过于频繁，暂时封禁"),
    E_202(202, "请求参数缺少必要字段"),
    E_203(203, "json格式有误"),

    E_300(300,"当前操作无权限"),
    E_301(301,"Token过期"),
    E_302(302,"签名sign无效"),
    E_303(303,"请求IP不被允许"),


    E_400(400,"网络错误"),
    E_401(401,"业务逻辑错误"),
    E_402(402,"数据库错误"),
    E_403(403,"文件操作错误"),
    E_404(404, "请求的服务不存在"),
    E_405(405,"调用第三方接口异常"),

    E_500(500,"记录未发现"),
    E_501(501,"数据库中存在重复的记录"),
    E_502(502,"无数据"),
    E_503(503,"系统保护数据，不可修改或删除"),

    E_1000(1000,"账号或者密码错误"),
    E_1001(1001,"账号已经被禁用"),
    E_1002(1002,"没有登录或者长时间未操作导致登录信息丢失");


    // 成员变量
    private int code;

    private String message;

    // 构造方法
    ErrorEnum(int code, String message) {
        this.code = code;
        this.message = message;
    }

    // 普通方法
    public static String getErrorMsg(int code) {
        for (ErrorEnum c : ErrorEnum.values()) {
            if (c.getCode() == code) {
                return c.message;
            }
        }
        return null;
    }

    public int getCode() {
        return code;
    }

    public void setCode(int code) {
        this.code = code;
    }

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }
}
